//---------------------------------------------------------------------------

#ifndef ThreadWorkerH
#define ThreadWorkerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------

#include "Job.h"
#include "Mutex.h"
#include <deque>

class ThreadWorker : public TThread
{
public:
	enum State
	{
		IDLE = 0,
		RUNNING,
		STOPPING
	};
private:
protected:
	void __fastcall Execute();
	std::deque<Job> jobs;
	Mutex mutex;
	enum State state;
	bool abort;
	int priority;
	bool &playSoundWhenDone;
public:
	__fastcall ThreadWorker(bool CreateSuspended, bool &playSoundWhenDone);
	void AddJob(Job& job);
	void Start(int priority);
	void Stop(void);
	enum State GetState(void) {
    	return state;
	}
	void AbortAll(void) {
		abort = true;
	}
};
//---------------------------------------------------------------------------
#endif
